package net.minecraft.src;

import net.lax1dude.eaglercraft.TextureLocation;
import net.lax1dude.eaglercraft.EaglerAdapter;

public class RenderGhast extends RenderLiving
{
    private static final TextureLocation ghastTextures = new TextureLocation("textures/entity/ghast/ghast.png");
    private static final TextureLocation ghastShootingTextures = new TextureLocation("textures/entity/ghast/ghast_shooting.png");

    public RenderGhast()
    {
        super(new ModelGhast(), 0.5F);
    }

    protected TextureLocation func_110867_a(EntityGhast par1EntityGhast)
    {
        return par1EntityGhast.func_110182_bF() ? ghastShootingTextures : ghastTextures;
    }

    /**
     * Pre-Renders the Ghast.
     */
    protected void preRenderGhast(EntityGhast par1EntityGhast, float par2)
    {
        float var4 = ((float)par1EntityGhast.prevAttackCounter + (float)(par1EntityGhast.attackCounter - par1EntityGhast.prevAttackCounter) * par2) / 20.0F;

        if (var4 < 0.0F)
        {
            var4 = 0.0F;
        }

        var4 = 1.0F / (var4 * var4 * var4 * var4 * var4 * 2.0F + 1.0F);
        float var5 = (8.0F + var4) / 2.0F;
        float var6 = (8.0F + 1.0F / var4) / 2.0F;
        EaglerAdapter.glScalef(var6, var5, var6);
        EaglerAdapter.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
    }

    @Override
    protected void bindTexture(EntityLivingBase par1EntityLiving) {
        if(par1EntityLiving.getDataWatcher().getWatchableObjectByte(16) == (byte)1) {
            ghastShootingTextures.bindTexture();
        }else {
            ghastTextures.bindTexture();
        }
    }

    /**
     * Allows the render to do any OpenGL state modifications necessary before the model is rendered. Args:
     * entityLiving, partialTickTime
     */
    protected void preRenderCallback(EntityLivingBase par1EntityLivingBase, float par2)
    {
        this.preRenderGhast((EntityGhast)par1EntityLivingBase, par2);
    }

    /**
     * Returns the location of an entity's texture. Doesn't seem to be called unless you call Render.bindEntityTexture.
     */
    protected TextureLocation getEntityTexture(Entity par1Entity)
    {
        return this.func_110867_a((EntityGhast)par1Entity);
    }
}
